<template>
  <q-page padding>
    <div class="row">
      <div class="col-md-3">
        <div style="background-color: lightgrey; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #c2c2c2; width: 85%; margin: 0 auto 0 auto">
          <h4 style="text-align: center; margin-bottom: 0">FILTER</h4>
        </div>
        <div style="box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #c2c2c2;  width: 85%; margin: 0 auto 0 auto">
          <q-list bordered class="rounded-borders">
            <div v-if="categoryActive">
              <q-expansion-item
                style="font-size: 18px"
                class="text-weight-bold"
                group="menu"
                expand-separator
                :label="categoryActive.product_type"
                :content-inset-level="1"
              >
                <q-list>
                  <q-item clickable v-ripple tag="a" :to="'/c/' + itemCategory.category" v-for="itemCategory in categoryActive.child">
                      <div @click="toLinkCategory(item.title)">
                        {{ itemCategory.category }}
                      </div>
                  </q-item>
                </q-list>
              </q-expansion-item>
            </div>
          </q-list>
        </div>
        <div style="box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #c2c2c2; height: 50px; background-color: lightgrey; width: 85%; margin: 0 auto 0 auto">
          <p>&nbsp;</p>
          <h6 class="text-weight-medium" style="margin-top: -30px; margin-left: 20px"> Filter lokasi</h6>
        </div>
        <div style="width: 85%; margin: 0 auto 0 auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #c2c2c2;">
          <p>&nbsp;</p>
          <q-input style="width: 80%; margin: -15px auto 0 auto" outlined bottom-slots v-model="text"  :dense="dense">
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>
        </div>
        <div style="box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #c2c2c2; height: 50px; background-color: lightgrey; width: 85%; margin: 0 auto 0 auto">
          <p>&nbsp;</p>
          <h6 class="text-weight-medium" style="margin-top: -30px; margin-left: 20px">Cari Produk</h6>
        </div>
        <div style="width: 85%; margin: 0 auto 0 auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #c2c2c2;">
          <p>&nbsp;</p>
          <q-input style="width: 80%; margin: -15px auto 10px auto" outlined bottom-slots v-model="text"  :dense="dense">
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>
          <p style="margin-top: 360px">&nbsp;</p>
        </div>

      </div>

      <div class="col-md-9">
        <h4 class="text-weight-medium" style="margin: 45px 0 5px auto"> {{ $route.params.category }}</h4>
        <div class="q-gutter-md" style="margin-bottom: 20px">
          <q-breadcrumbs>
            <q-breadcrumbs-el label="Beranda" />
            <q-breadcrumbs-el label="Category" />
            <q-breadcrumbs-el :label="$route.params.category" />
          </q-breadcrumbs>
        </div>
        <q-card>
          <q-card-section>
            <p >Halaman ke {{ slide }},  Total Produk {{ product.length }}</p>
          </q-card-section>

          <div class="q-pa-md">
            <q-carousel
              v-model="slide"
              transition-prev="slide-right"
              transition-next="slide-left"
              animated
              control-color="primary"
              class="rounded-borders"
              style="height: 100%; "
            >
              <q-carousel-slide v-for="itemHalaman in jmlHalaman" :name="itemHalaman" class="column no-wrap flex-center">
                <div class="row fit justify-center items-center q-gutter-xs q-col-gutter" style="margin-bottom: 10px">
                  <q-card v-for="item in 6" class="col-3 my-card items-center hover-grey"  style="cursor: pointer" flat bordered v-if="product[(( itemHalaman - 1 ) * 6) + (item - 1)]">
                    <q-img @click="$router.push('/product/' + product[(( itemHalaman - 1 ) * 6) + (item - 1)].id)" :src="product[(( itemHalaman - 1 ) * 6) + (item - 1)].main_image" v-if="product[(( itemHalaman - 1 ) * 6) + (item - 1)].main_image != ''" style="height: 200px; object-fit: cover"/>
                    <q-img @click="$router.push('/product/' + product[(( itemHalaman - 1 ) * 6) + (item - 1)].id)" src="~assets/no_photo.png" v-else style="height: 200px; object-fit: cover"/>
                    <q-card-section style="padding-top: 0px; white-space: nowrap;overflow: hidden;text-overflow: ellipsis">
                      <div style="height: 64px; white-space: normal" class="text-h5 q-mt-sm q-mb-xs ellipsis-2-lines" @click="goToDetail(product[(( itemHalaman - 1 ) * 6) + (item - 1)].id)">{{ product[(( itemHalaman - 1 ) * 6) + (item - 1)].name_product }}</div>
                      <div style="margin-top: 20px" class="text-caption text-grey" v-if="!product[(( itemHalaman - 1 ) * 6) + (item - 1)].price_prone_flag">Rp. {{ product[(( itemHalaman - 1 ) * 6) + (item - 1)].price }} </div>
                      <div style="margin-top: 20px" class="text-caption text-grey" v-if="product[(( itemHalaman - 1 ) * 6) + (item - 1)].price_prone_flag">Rp. {{ product[(( itemHalaman - 1 ) * 6) + (item - 1)].starting_price }} - {{ product[(( itemHalaman - 1 ) * 6) + (item - 1)].final_price }} </div>
                      <div class="row" style="margin-top: 10px">
                        <q-icon name="location_on" size="150%"></q-icon>
                        <p class="ellipsis-2-lines">{{ (product[(( itemHalaman - 1 ) * 6) + (item - 1)].address.kota) ? product[(( itemHalaman - 1 ) * 6) + (item - 1)].address.kota.name : "Indonesia" }}</p>
                      </div>
                    </q-card-section>
                  </q-card>
                </div>
              </q-carousel-slide>

            </q-carousel>

            <div class="row justify-center">
              <q-btn-toggle
                glossy
                v-model="slide"
                :options="paginate"
              />
            </div>
          </div>
        </q-card>
      </div>
    </div>
  </q-page>
</template>

<script>
export default {
  name: 'HalamanKategori',

  data () {
    return {
      category: this.$route.params.category,
      slide: 1,
      lorem: 'Lorem ipsum dolor, sit amet consectetur adipisicing elit. Itaque voluptatem totam, architecto cupiditate officia rerum, error dignissimos praesentium libero ab nemo provident incidunt ducimus iusto perferendis porro earum. Totam, numquam?',
      text: '',
      ph: '',
      dense: false,
      jmlHalaman: 1
    }
  },

  preFetch (store) {
    store.store.dispatch("product/getProductByKategori", store.currentRoute.params.category);
    store.store.dispatch("kategori/getSelectkategori")
    store.store.dispatch("ProductType/getSelectProductType")
  },

  beforeMount() {
  },

  computed: {
    product() {
      return this.$store.state.product.productListCategory;
    },

    categoryActive() {
      return this.$store.state.product.categoryActice;
    },

    paginate() {
      this.jmlHalaman = Math.floor(parseInt(this.product.length)/6);
      if (this.jmlHalaman == 0) {
        this.jmlHalaman = 1
      }

      let page = [];

      for (let i = 1; i <= this.jmlHalaman; i++) {
        page.push({
          label: i,
          value: i
        })
      }

      return page;
    },

    selectKategori() {
      let data = this.$store.state.kategori.selectKategori;
      if (!data) {
        return [];
      } else {
        return data;
      }
    },

    selectProductType() {
      return this.$store.state.ProductType.selectProductType;
    }
  },

  methods: {
    toLinkCategory: function (category) {
      this.$router.push("/c/" + category)
    },

    goToDetail: function (id) {
      this.$router.push("/product/" + id);
    }
  }

}
</script>
